stages:
    - build
    - test
    - deploiement
    - docker
    - test docker

include:
    - template: Code-Quality.gitlab-ci.yml

default:
    image: node:14

variables:
    URL_TEST: http://test.site.formationgitlab.surge.sh/
    URL_PROD: http://production.site.formationgitlab.surge.sh/
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
    IMAGE_TAG_LATEST: $CI_REGISTRY_IMAGE:latest

build:
    stage: build
    cache:
        key: $CI_COMMIT_REF_SLUG
        paths:
            - .npm/
    script:
        - npm ci --cache .npm --prefer-offline
        - npm run build
    artifacts:
        paths:
            - public/

.test ok:
    stage: test
    image: alpine:latest
    script:
        - grep "build something great" ./public/index.html

test reel:
    stage: test
    cache:
        key: $CI_COMMIT_REF_SLUG
        paths:
            - .npm/
        policy: pull
    script:
        - npm ci --cache .npm --prefer-offline
        - npm run serve &
        - sleep 10
        - curl http://localhost:9000 | tac | tac | grep -q "build"

deploiement test:
    stage: deploiement
    environment: 
        name: test
        url: http://$URL_TEST
        on_stop: arret test
    only:
        - master
    script:
        - npx surge --project ./public --domain $URL_TEST

arret test:
    stage: deploiement
    only:
        - master
    environment: 
        name: test
        action: stop
    when: manual
    script:
        - npx surge teardown $URL_TEST

deploiement production:
    stage: deploiement
    when: manual
    environment: production
    only:
        - master
    script:
        - npx surge --project ./public --domain $URL_PROD

image docker:
    stage: docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker build -t $IMAGE_TAG -t $IMAGE_TAG_LATEST .
        - docker push $IMAGE_TAG
        - docker push $IMAGE_TAG_LATEST

test image docker:
    stage: test docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    before_script:
        - apk add --update curl
    script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker pull $IMAGE_TAG
        - docker run -d -p 8080:80 --name website $IMAGE_TAG
        - sleep 10
        - curl http://docker:8080 | tac | tac | grep -q "build "

